SystemOrganization addCategory: #SSpec!

TestCase subclass: #Spec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SSpec'!

!Spec class methodsFor: 'testing' stamp: 'tfel 5/5/2011 17:54:55.02'!
isAbstract

	^ self name = #Spec! !

!Spec class methodsFor: 'Accessing' stamp: 'tfel 5/9/2011 15:14:03.906'!
testSelectors

	^(self selectors asArray select: [ :each | 
		((each beginsWith: 'test') or: [each beginsWith: 'should']) and: [ each numArgs isZero ] ]) sort! !

!Spec methodsFor: 'expectations' stamp: 'tfel 5/5/2011 17:49:31.174'!
assert: aBlock sends: aNumber times: aSelector to: anObject

	self mutate: anObject andDo: [| mw |
		mw := MwCountMethodWrapper 
				on: aSelector 
				inClass: (anObject isBehavior ifTrue: [anObject] ifFalse: [anObject class]).
		mw install.
		[
			aBlock value.
			self 
				assert: [mw count = aNumber]
				description: 'Expected ', anObject printString, ' to receive ',
							aSelector, ' ', aNumber, ' times, but got ', mw count, ' times']
		ensure: [mw uninstall]]! !

!Spec methodsFor: 'expectations' stamp: 'tfel 5/5/2011 17:49:31.249'!
assert: aBlock sends: aSelector to: anObject

	self assert: aBlock sends: 1 times: aSelector to: anObject.! !

!Spec methodsFor: 'expectations' stamp: 'tfel 7/14/2011 15:00:48.36'!
mock: aSelector of: aClass toReturn: aBlockOrObject during: aBlock
	| mw |
	mw := SpecMockingMethodWrapper on: aSelector inClass: aClass returning: aBlockOrObject.
	mw installClosestToMethod. "We don't call the method, but other wrappers need to work before us"
	[aBlock value] ensure: [mw uninstall].
! !

!Spec methodsFor: 'expectations' stamp: 'tfel 5/5/2011 17:49:31.301'!
mutate: anObject andDo: aBlock
	"Creates a singleton class for the specified object and evaluates the block, then changes the object's class back"
	anObject isBehavior ifTrue: [^ aBlock value].
	anObject class class == Metaclass ifTrue: [self error: 'Cannot mutate the Metaclass.'].
	anObject class class new
		superclass: (anObject class);
		setFormat: (anObject class format);
		methodDict: MethodDictionary new;
		adoptInstance: anObject.
	[^ aBlock value]
		ensure: [anObject class superclass adoptInstance: anObject].! !

MwMethodWrapper subclass: #SpecCountMethodWrapper
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SSpec'!

!SpecCountMethodWrapper class methodsFor: 'class initialization' stamp: 'tfel 5/5/2011 17:53:28.3'!
initialize
	"doIt: [self initialize]"

	super initialize.! !

!SpecCountMethodWrapper methodsFor: 'evaluating' stamp: 'tfel 5/5/2011 17:53:28.259'!
beforeMethod

	self count: self count + 1.! !

!SpecCountMethodWrapper methodsFor: 'initialization' stamp: 'tfel 5/5/2011 17:53:28.27'!
class: aClass selector: aSymbol

	self count: 0.
	^ super class: aClass selector: aSymbol! !

!SpecCountMethodWrapper methodsFor: 'derived accessing' stamp: 'tfel 5/5/2011 17:53:28.28'!
count

	^ count! !

!SpecCountMethodWrapper methodsFor: 'derived accessing' stamp: 'tfel 5/5/2011 17:53:28.29'!
count: anInteger

	count := anInteger.! !

MwMethodWrapper subclass: #SpecMockingMethodWrapper
	instanceVariableNames: 'returnValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SSpec'!

!SpecMockingMethodWrapper class methodsFor: 'class initialization' stamp: 'tfel 5/5/2011 17:54:24.679'!
initialize

	super initialize.! !

!SpecMockingMethodWrapper class methodsFor: 'instance creation' stamp: 'tfel 5/5/2011 15:50:28.381'!
on: aSelector inClass: aClass returning: anObject

	^ (self on: aSelector inClass: aClass)
		returnValue: anObject;
		yourself! !

!SpecMockingMethodWrapper methodsFor: 'accessing' stamp: 'tfel 5/5/2011 15:50:51.963'!
returnValue: anObject
	returnValue := anObject! !

!SpecMockingMethodWrapper methodsFor: 'evaluating' stamp: 'tfel 5/9/2011 10:54:14.04'!
valueWithReceiver: anObject arguments: anArrayOfObjects
	"This is the general case where you want both a before and after method, but if you
	want just a before method, you might want to override this method for optimization."

	self beforeMethod.
	^ [ returnValue isBlock
			ifTrue: [returnValue
						valueWithEnoughArguments: ({anObject} asOrderedCollection
															addAll: anArrayOfObjects;
															yourself) asArray]
			ifFalse: returnValue ] ensure: [self afterMethod]! !
SpecCountMethodWrapper initialize!
SpecMockingMethodWrapper initialize!
